diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/lte/model/lte-enb-rrc.cc ns-3.40/src/lte/model/lte-enb-rrc.cc
--- ns-3.39/src/lte/model/lte-enb-rrc.cc	2023-07-05 14:23:48.009428000 -0700
+++ ns-3.40/src/lte/model/lte-enb-rrc.cc	2023-09-27 13:30:37.818839600 -0700
@@ -320,9 +320,7 @@
 {
     delete m_drbPdcpSapUser;
     // delete eventual X2-U TEIDs
-    for (std::map<uint8_t, Ptr<LteDataRadioBearerInfo>>::iterator it = m_drbMap.begin();
-         it != m_drbMap.end();
-         ++it)
+    for (auto it = m_drbMap.begin(); it != m_drbMap.end(); ++it)
     {
         m_rrc->m_x2uTeidInfoMap.erase(it->second->m_gtpTeid);
     }
@@ -425,9 +423,8 @@
         LteEnbRrc::X2uTeidInfo x2uTeidInfo;
         x2uTeidInfo.rnti = m_rnti;
         x2uTeidInfo.drbid = drbid;
-        std::pair<std::map<uint32_t, LteEnbRrc::X2uTeidInfo>::iterator, bool> ret =
-            m_rrc->m_x2uTeidInfoMap.insert(
-                std::pair<uint32_t, LteEnbRrc::X2uTeidInfo>(gtpTeid, x2uTeidInfo));
+        auto ret = m_rrc->m_x2uTeidInfoMap.insert(
+            std::pair<uint32_t, LteEnbRrc::X2uTeidInfo>(gtpTeid, x2uTeidInfo));
         NS_ASSERT_MSG(ret.second == true, "overwriting a pre-existing entry in m_x2uTeidInfoMap");
     }
 
@@ -478,7 +475,7 @@
     // lcinfo.gbrDl = bearer.gbrQosInfo.gbrDl;
     // use a for cycle to send the AddLc to the appropriate Mac Sap
     // if the sap is not initialized the appropriated method has to be called
-    std::vector<LteCcmRrcSapProvider::LcsConfig>::iterator itLcOnCcMapping = lcOnCcMapping.begin();
+    auto itLcOnCcMapping = lcOnCcMapping.begin();
     NS_ASSERT_MSG(itLcOnCcMapping != lcOnCcMapping.end(), "Problem");
     for (itLcOnCcMapping = lcOnCcMapping.begin(); itLcOnCcMapping != lcOnCcMapping.end();
          ++itLcOnCcMapping)
@@ -523,9 +520,7 @@
 UeManager::RecordDataRadioBearersToBeStarted()
 {
     NS_LOG_FUNCTION(this << (uint32_t)m_rnti);
-    for (std::map<uint8_t, Ptr<LteDataRadioBearerInfo>>::iterator it = m_drbMap.begin();
-         it != m_drbMap.end();
-         ++it)
+    for (auto it = m_drbMap.begin(); it != m_drbMap.end(); ++it)
     {
         m_drbsToBeStarted.push_back(it->first);
     }
@@ -535,11 +530,9 @@
 UeManager::StartDataRadioBearers()
 {
     NS_LOG_FUNCTION(this << (uint32_t)m_rnti);
-    for (std::list<uint8_t>::iterator drbIdIt = m_drbsToBeStarted.begin();
-         drbIdIt != m_drbsToBeStarted.end();
-         ++drbIdIt)
+    for (auto drbIdIt = m_drbsToBeStarted.begin(); drbIdIt != m_drbsToBeStarted.end(); ++drbIdIt)
     {
-        std::map<uint8_t, Ptr<LteDataRadioBearerInfo>>::iterator drbIt = m_drbMap.find(*drbIdIt);
+        auto drbIt = m_drbMap.find(*drbIdIt);
         NS_ASSERT(drbIt != m_drbMap.end());
         drbIt->second->m_rlc->Initialize();
         if (drbIt->second->m_pdcp)
@@ -555,7 +548,7 @@
 {
     NS_LOG_FUNCTION(this << (uint32_t)m_rnti << (uint32_t)drbid);
     uint8_t lcid = Drbid2Lcid(drbid);
-    std::map<uint8_t, Ptr<LteDataRadioBearerInfo>>::iterator it = m_drbMap.find(drbid);
+    auto it = m_drbMap.find(drbid);
     NS_ASSERT_MSG(it != m_drbMap.end(),
                   "request to remove radio bearer with unknown drbid " << drbid);
 
@@ -565,7 +558,7 @@
     m_drbMap.erase(it);
     std::vector<uint8_t> ccToRelease =
         m_rrc->m_ccmRrcSapProvider->ReleaseDataRadioBearer(m_rnti, lcid);
-    std::vector<uint8_t>::iterator itCcToRelease = ccToRelease.begin();
+    auto itCcToRelease = ccToRelease.begin();
     NS_ASSERT_MSG(itCcToRelease != ccToRelease.end(),
                   "request to remove radio bearer with unknown drbid (ComponentCarrierManager)");
     for (itCcToRelease = ccToRelease.begin(); itCcToRelease != ccToRelease.end(); ++itCcToRelease)
@@ -856,9 +849,7 @@
     sst.newEnbUeX2apId = params.newEnbUeX2apId;
     sst.sourceCellId = params.sourceCellId;
     sst.targetCellId = params.targetCellId;
-    for (std::map<uint8_t, Ptr<LteDataRadioBearerInfo>>::iterator drbIt = m_drbMap.begin();
-         drbIt != m_drbMap.end();
-         ++drbIt)
+    for (auto drbIt = m_drbMap.begin(); drbIt != m_drbMap.end(); ++drbIt)
     {
         // SN status transfer is only for AM RLC
         if (drbIt->second->m_rlc->GetObject<LteRlcAm>())
@@ -939,12 +930,13 @@
     params.lcid = Bid2Lcid(bid);
     uint8_t drbid = Bid2Drbid(bid);
     // Transmit PDCP sdu only if DRB ID found in drbMap
-    std::map<uint8_t, Ptr<LteDataRadioBearerInfo>>::iterator it = m_drbMap.find(drbid);
+    auto it = m_drbMap.find(drbid);
     if (it != m_drbMap.end())
     {
         Ptr<LteDataRadioBearerInfo> bearerInfo = GetDataRadioBearerInfo(drbid);
         if (bearerInfo)
         {
+            NS_LOG_INFO("Send packet to PDCP layer");
             LtePdcpSapProvider* pdcpSapProvider = bearerInfo->m_pdcp->GetLtePdcpSapProvider();
             pdcpSapProvider->TransmitPdcpSdu(params);
         }
@@ -967,20 +959,20 @@
     case CONNECTION_REESTABLISHMENT:
     case HANDOVER_PREPARATION:
     case HANDOVER_PATH_SWITCH: {
-        NS_LOG_LOGIC("queueing data on PDCP for transmission over the air");
+        NS_LOG_INFO("queueing data on PDCP for transmission over the air");
         SendPacket(bid, p);
     }
     break;
 
     case HANDOVER_JOINING: {
         // Buffer data until RRC Connection Reconfiguration Complete message is received
-        NS_LOG_LOGIC("buffering data");
+        NS_LOG_INFO("buffering data");
         m_packetBuffer.emplace_back(bid, p);
     }
     break;
 
     case HANDOVER_LEAVING: {
-        NS_LOG_LOGIC("forwarding data to target eNB over X2-U");
+        NS_LOG_INFO("forwarding data to target eNB over X2-U");
         uint8_t drbid = Bid2Drbid(bid);
         EpcX2Sap::UeDataParams params;
         params.sourceCellId = m_rrc->ComponentCarrierToCellId(m_componentCarrierId);
@@ -1002,9 +994,7 @@
 {
     NS_LOG_FUNCTION(this);
     std::vector<EpcX2Sap::ErabToBeSetupItem> ret;
-    for (std::map<uint8_t, Ptr<LteDataRadioBearerInfo>>::iterator it = m_drbMap.begin();
-         it != m_drbMap.end();
-         ++it)
+    for (auto it = m_drbMap.begin(); it != m_drbMap.end(); ++it)
     {
         EpcX2Sap::ErabToBeSetupItem etbsi;
         etbsi.erabId = it->second->m_epsBearerIdentity;
@@ -1079,8 +1069,7 @@
 UeManager::RecvSnStatusTransfer(EpcX2SapUser::SnStatusTransferParams params)
 {
     NS_LOG_FUNCTION(this);
-    for (std::vector<EpcX2Sap::ErabsSubjectToStatusTransferItem>::iterator erabIt =
-             params.erabsSubjectToStatusTransferList.begin();
+    for (auto erabIt = params.erabsSubjectToStatusTransferList.begin();
          erabIt != params.erabsSubjectToStatusTransferList.end();
          ++erabIt)
     {
@@ -1088,7 +1077,7 @@
         // status.txSn = erabIt->dlPdcpSn;
         // status.rxSn = erabIt->ulPdcpSn;
         // uint8_t drbId = Bid2Drbid (erabIt->erabId);
-        // std::map <uint8_t, Ptr<LteDataRadioBearerInfo> >::iterator drbIt = m_drbMap.find (drbId);
+        // auto drbIt = m_drbMap.find (drbId);
         // NS_ASSERT_MSG (drbIt != m_drbMap.end (), "could not find DRBID " << (uint32_t) drbId);
         // drbIt->second->m_pdcp->SetStatus (status);
     }
@@ -1293,9 +1282,7 @@
         params.cellId = m_rrc->ComponentCarrierToCellId(m_componentCarrierId);
         params.mmeUeS1Id = m_imsi;
         SwitchToState(HANDOVER_PATH_SWITCH);
-        for (std::map<uint8_t, Ptr<LteDataRadioBearerInfo>>::iterator it = m_drbMap.begin();
-             it != m_drbMap.end();
-             ++it)
+        for (auto it = m_drbMap.begin(); it != m_drbMap.end(); ++it)
         {
             EpcEnbS1SapProvider::BearerToBeSwitched b;
             b.epsBearerId = it->second->m_epsBearerIdentity;
@@ -1362,8 +1349,7 @@
                  << (uint16_t)msg.measResults.measResultPCell.rsrpResult << " RSRQ "
                  << (uint16_t)msg.measResults.measResultPCell.rsrqResult);
 
-    for (std::list<LteRrcSap::MeasResultEutra>::iterator it =
-             msg.measResults.measResultListEutra.begin();
+    for (auto it = msg.measResults.measResultListEutra.begin();
          it != msg.measResults.measResultListEutra.end();
          ++it)
     {
@@ -1586,7 +1572,7 @@
 {
     NS_LOG_FUNCTION(this << (uint32_t)drbid);
     NS_ASSERT(0 != drbid);
-    std::map<uint8_t, Ptr<LteDataRadioBearerInfo>>::iterator it = m_drbMap.find(drbid);
+    auto it = m_drbMap.find(drbid);
     NS_ABORT_IF(it == m_drbMap.end());
     return it->second;
 }
@@ -1595,7 +1581,7 @@
 UeManager::RemoveDataRadioBearerInfo(uint8_t drbid)
 {
     NS_LOG_FUNCTION(this << (uint32_t)drbid);
-    std::map<uint8_t, Ptr<LteDataRadioBearerInfo>>::iterator it = m_drbMap.find(drbid);
+    auto it = m_drbMap.find(drbid);
     NS_ASSERT_MSG(it != m_drbMap.end(),
                   "request to remove radio bearer with unknown drbid " << drbid);
     m_drbMap.erase(it);
@@ -1642,9 +1628,7 @@
         rrcd.srbToAddModList.push_back(stam);
     }
 
-    for (std::map<uint8_t, Ptr<LteDataRadioBearerInfo>>::iterator it = m_drbMap.begin();
-         it != m_drbMap.end();
-         ++it)
+    for (auto it = m_drbMap.begin(); it != m_drbMap.end(); ++it)
     {
         LteRrcSap::DrbToAddMod dtam;
         dtam.epsBearerIdentity = it->second->m_epsBearerIdentity;
@@ -1939,7 +1923,6 @@
 TypeId
 LteEnbRrc::GetTypeId()
 {
-    NS_LOG_FUNCTION("LteEnbRrc::GetTypeId");
     static TypeId tid =
         TypeId("ns3::LteEnbRrc")
             .SetParent<Object>()
@@ -2351,7 +2334,7 @@
 LteEnbRrc::HasUeManager(uint16_t rnti) const
 {
     NS_LOG_FUNCTION(this << (uint32_t)rnti);
-    std::map<uint16_t, Ptr<UeManager>>::const_iterator it = m_ueMap.find(rnti);
+    auto it = m_ueMap.find(rnti);
     return (it != m_ueMap.end());
 }
 
@@ -2360,7 +2343,7 @@
 {
     NS_LOG_FUNCTION(this << (uint32_t)rnti);
     NS_ASSERT(0 != rnti);
-    std::map<uint16_t, Ptr<UeManager>>::iterator it = m_ueMap.find(rnti);
+    auto it = m_ueMap.find(rnti);
     NS_ASSERT_MSG(it != m_ueMap.end(), "UE manager for RNTI " << rnti << " not found");
     return it->second;
 }
@@ -2616,11 +2599,14 @@
 LteEnbRrc::SendData(Ptr<Packet> packet)
 {
     NS_LOG_FUNCTION(this << packet);
-
     EpsBearerTag tag;
     bool found = packet->RemovePacketTag(tag);
     NS_ASSERT_MSG(found, "no EpsBearerTag found in packet to be sent");
     Ptr<UeManager> ueManager = GetUeManager(tag.GetRnti());
+
+    NS_LOG_INFO("Sending a packet of " << packet->GetSize() << " bytes to IMSI "
+                                       << ueManager->GetImsi() << ", RNTI " << ueManager->GetRnti()
+                                       << ", BID " << (uint16_t)tag.GetBid());
     ueManager->SendData(tag.GetBid(), packet);
 
     return true;
@@ -2916,9 +2902,7 @@
     ackParams.sourceCellId = req.sourceCellId;
     ackParams.targetCellId = req.targetCellId;
 
-    for (std::vector<EpcX2Sap::ErabToBeSetupItem>::iterator it = req.bearers.begin();
-         it != req.bearers.end();
-         ++it)
+    for (auto it = req.bearers.begin(); it != req.bearers.end(); ++it)
     {
         ueManager->SetupDataRadioBearer(it->erabLevelQosParameters,
                                         it->erabId,
@@ -3083,7 +3067,7 @@
     NS_LOG_LOGIC("ueData = " << params.ueData);
     NS_LOG_LOGIC("ueData size = " << params.ueData->GetSize());
 
-    std::map<uint32_t, X2uTeidInfo>::iterator teidInfoIt = m_x2uTeidInfoMap.find(params.gtpTeid);
+    auto teidInfoIt = m_x2uTeidInfoMap.find(params.gtpTeid);
     if (teidInfoIt != m_x2uTeidInfoMap.end())
     {
         GetUeManager(teidInfoIt->second.rnti)->SendData(teidInfoIt->second.drbid, params.ueData);
@@ -3276,7 +3260,7 @@
 LteEnbRrc::RemoveUe(uint16_t rnti)
 {
     NS_LOG_FUNCTION(this << (uint32_t)rnti);
-    std::map<uint16_t, Ptr<UeManager>>::iterator it = m_ueMap.find(rnti);
+    auto it = m_ueMap.find(rnti);
     NS_ASSERT_MSG(it != m_ueMap.end(), "request to remove UE info with unknown rnti " << rnti);
     uint64_t imsi = it->second->GetImsi();
     uint16_t srsCi = (*it).second->GetSrsConfigurationIndex();
@@ -3438,7 +3422,7 @@
     else
     {
         // find a CI from the available ones
-        std::set<uint16_t>::reverse_iterator rit = m_ueSrsConfigurationIndexSet.rbegin();
+        auto rit = m_ueSrsConfigurationIndexSet.rbegin();
         NS_ASSERT(rit != m_ueSrsConfigurationIndexSet.rend());
         NS_LOG_DEBUG(this << " lower bound " << (*rit) << " of "
                           << g_srsCiHigh[m_srsCurrentPeriodicityId]);
@@ -3455,7 +3439,7 @@
                  srcCi < g_srsCiHigh[m_srsCurrentPeriodicityId];
                  srcCi++)
             {
-                std::set<uint16_t>::iterator it = m_ueSrsConfigurationIndexSet.find(srcCi);
+                auto it = m_ueSrsConfigurationIndexSet.find(srcCi);
                 if (it == m_ueSrsConfigurationIndexSet.end())
                 {
                     m_lastAllocatedConfigurationIndex = srcCi;
@@ -3472,7 +3456,7 @@
 LteEnbRrc::RemoveSrsConfigurationIndex(uint16_t srcCi)
 {
     NS_LOG_FUNCTION(this << srcCi);
-    std::set<uint16_t>::iterator it = m_ueSrsConfigurationIndexSet.find(srcCi);
+    auto it = m_ueSrsConfigurationIndexSet.find(srcCi);
     NS_ASSERT_MSG(it != m_ueSrsConfigurationIndexSet.end(),
                   "request to remove unknown SRS CI " << srcCi);
     m_ueSrsConfigurationIndexSet.erase(it);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/lte/model/lte-ffr-distributed-algorithm.cc ns-3.40/src/lte/model/lte-ffr-distributed-algorithm.cc
--- ns-3.39/src/lte/model/lte-ffr-distributed-algorithm.cc	2023-07-05 14:23:48.013428000 -0700
+++ ns-3.40/src/lte/model/lte-ffr-distributed-algorithm.cc	2023-09-27 13:30:37.818839600 -0700
@@ -247,7 +247,7 @@
 
     bool edgeRbg = m_dlEdgeRbgMap[rbgId];
 
-    std::map<uint16_t, uint8_t>::iterator it = m_ues.find(rnti);
+    auto it = m_ues.find(rnti);
     if (it == m_ues.end())
     {
         m_ues.insert(std::pair<uint16_t, uint8_t>(rnti, AreaUnset));
@@ -288,7 +288,7 @@
 
     bool edgeRbg = m_ulEdgeRbgMap[rbId];
 
-    std::map<uint16_t, uint8_t>::iterator it = m_ues.find(rnti);
+    auto it = m_ues.find(rnti);
     if (it == m_ues.end())
     {
         m_ues.insert(std::pair<uint16_t, uint8_t>(rnti, AreaUnset));
@@ -348,7 +348,7 @@
     //------------------------------------------------
     //  here Absolute mode is used
 
-    std::map<uint16_t, uint8_t>::iterator it = m_ues.find(rnti);
+    auto it = m_ues.find(rnti);
     if (it == m_ues.end())
     {
         return 1;
@@ -397,7 +397,7 @@
     if (measResults.measId == m_rsrqMeasId)
     {
         // check if it is center or edge UE
-        std::map<uint16_t, uint8_t>::iterator it = m_ues.find(rnti);
+        auto it = m_ues.find(rnti);
         if (it == m_ues.end())
         {
             m_ues.insert(std::pair<uint16_t, uint8_t>(rnti, AreaUnset));
@@ -431,7 +431,7 @@
     }
     else if (measResults.measId == m_rsrpMeasId)
     {
-        std::map<uint16_t, uint8_t>::iterator it = m_ues.find(rnti);
+        auto it = m_ues.find(rnti);
         if (it == m_ues.end())
         {
             m_ues.insert(std::pair<uint16_t, uint8_t>(rnti, AreaUnset));
@@ -444,8 +444,7 @@
 
         if (measResults.haveMeasResultNeighCells && !measResults.measResultListEutra.empty())
         {
-            for (std::list<LteRrcSap::MeasResultEutra>::iterator it =
-                     measResults.measResultListEutra.begin();
+            for (auto it = measResults.measResultListEutra.begin();
                  it != measResults.measResultListEutra.end();
                  ++it)
             {
@@ -456,9 +455,7 @@
                 UpdateNeighbourMeasurements(rnti, it->physCellId, it->rsrpResult, it->rsrqResult);
 
                 bool found = false;
-                for (std::vector<uint16_t>::iterator ncIt = m_neighborCell.begin();
-                     ncIt != m_neighborCell.end();
-                     ncIt++)
+                for (auto ncIt = m_neighborCell.begin(); ncIt != m_neighborCell.end(); ncIt++)
                 {
                     if ((*ncIt) == it->physCellId)
                     {
@@ -499,14 +496,11 @@
     m_ulEdgeRbgMap.clear();
     m_ulEdgeRbgMap.resize(m_ulBandwidth, false);
 
-    MeasurementTable_t::iterator it1;
-    MeasurementRow_t::iterator it2;
     Ptr<UeMeasure> servingCellMeasures;
     Ptr<UeMeasure> neighbourCellMeasures;
 
     uint32_t edgeUeNum = 0;
-    std::map<uint16_t, uint8_t>::iterator areaIt;
-    for (areaIt = m_ues.begin(); areaIt != m_ues.end(); areaIt++)
+    for (auto areaIt = m_ues.begin(); areaIt != m_ues.end(); areaIt++)
     {
         if (areaIt->second == EdgeArea)
         {
@@ -516,9 +510,9 @@
 
     if (edgeUeNum != 0)
     {
-        for (it1 = m_ueMeasures.begin(); it1 != m_ueMeasures.end(); it1++)
+        for (auto it1 = m_ueMeasures.begin(); it1 != m_ueMeasures.end(); it1++)
         {
-            std::map<uint16_t, uint8_t>::iterator areaIt = m_ues.find(it1->first);
+            auto areaIt = m_ues.find(it1->first);
             if (areaIt->second != EdgeArea)
             {
                 continue;
@@ -527,7 +521,7 @@
             servingCellMeasures = nullptr;
             neighbourCellMeasures = nullptr;
 
-            it2 = it1->second.find(m_cellId);
+            auto it2 = it1->second.find(m_cellId);
             if (it2 != it1->second.end())
             {
                 servingCellMeasures = it2->second;
@@ -573,13 +567,12 @@
             metricA[i] = 0;
         }
 
-        std::map<uint16_t, uint32_t>::iterator cellIt;
-        for (cellIt = m_cellWeightMap.begin(); cellIt != m_cellWeightMap.end(); cellIt++)
+        for (auto cellIt = m_cellWeightMap.begin(); cellIt != m_cellWeightMap.end(); cellIt++)
         {
             NS_LOG_INFO("CellId: " << m_cellId << " NeighborCellId: " << cellIt->first
                                    << " Weight: " << cellIt->second);
 
-            std::map<uint16_t, std::vector<bool>>::iterator rntpIt = m_rntp.find(cellIt->first);
+            auto rntpIt = m_rntp.find(cellIt->first);
             if (rntpIt == m_rntp.end())
             {
                 continue;
@@ -596,15 +589,12 @@
 
         std::vector<uint16_t> sortedRbgByMetric;
         std::multimap<uint64_t, uint16_t> sortedMetricA;
-        for (std::map<uint16_t, uint64_t>::const_iterator it = metricA.begin(); it != metricA.end();
-             ++it)
+        for (auto it = metricA.begin(); it != metricA.end(); ++it)
         {
             sortedMetricA.insert(std::pair<uint64_t, uint16_t>(it->second, it->first));
         }
 
-        for (std::multimap<uint64_t, uint16_t>::const_iterator it = sortedMetricA.begin();
-             it != sortedMetricA.end();
-             ++it)
+        for (auto it = sortedMetricA.begin(); it != sortedMetricA.end(); ++it)
         {
             sortedRbgByMetric.push_back(it->second);
         }
@@ -625,9 +615,7 @@
         }
     }
 
-    for (std::vector<uint16_t>::iterator ncIt = m_neighborCell.begin();
-         ncIt != m_neighborCell.end();
-         ncIt++)
+    for (auto ncIt = m_neighborCell.begin(); ncIt != m_neighborCell.end(); ncIt++)
     {
         SendLoadInformation((*ncIt));
     }
@@ -674,7 +662,7 @@
     }
 
     uint16_t neighborCellId = params.cellInformationList[0].sourceCellId;
-    std::map<uint16_t, std::vector<bool>>::iterator it = m_rntp.find(neighborCellId);
+    auto it = m_rntp.find(neighborCellId);
     if (it != m_rntp.end())
     {
         it->second = params.cellInformationList[0].relativeNarrowbandTxBand.rntpPerPrbList;
@@ -695,22 +683,19 @@
 {
     NS_LOG_FUNCTION(this << rnti << cellId << (uint16_t)rsrq);
 
-    MeasurementTable_t::iterator it1;
-    it1 = m_ueMeasures.find(rnti);
+    auto it1 = m_ueMeasures.find(rnti);
 
     if (it1 == m_ueMeasures.end())
     {
         // insert a new UE entry
         MeasurementRow_t row;
-        std::pair<MeasurementTable_t::iterator, bool> ret;
-        ret = m_ueMeasures.insert(std::pair<uint16_t, MeasurementRow_t>(rnti, row));
+        auto ret = m_ueMeasures.insert(std::pair<uint16_t, MeasurementRow_t>(rnti, row));
         NS_ASSERT(ret.second);
         it1 = ret.first;
     }
 
     NS_ASSERT(it1 != m_ueMeasures.end());
-    std::map<uint16_t, Ptr<UeMeasure>>::iterator it2;
-    it2 = it1->second.find(cellId);
+    auto it2 = it1->second.find(cellId);
 
     if (it2 != it1->second.end())
     {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/lte/model/lte-ffr-enhanced-algorithm.cc ns-3.40/src/lte/model/lte-ffr-enhanced-algorithm.cc
--- ns-3.39/src/lte/model/lte-ffr-enhanced-algorithm.cc	2023-07-05 14:23:48.013428000 -0700
+++ ns-3.40/src/lte/model/lte-ffr-enhanced-algorithm.cc	2023-09-27 13:30:37.818839600 -0700
@@ -478,8 +478,7 @@
 
     std::vector<bool> rbgMap = m_dlRbgMap;
 
-    std::map<uint16_t, std::vector<bool>>::iterator it;
-    for (it = m_dlRbgAvailableforUe.begin(); it != m_dlRbgAvailableforUe.end(); it++)
+    for (auto it = m_dlRbgAvailableforUe.begin(); it != m_dlRbgAvailableforUe.end(); it++)
     {
         NS_LOG_INFO("RNTI : " << it->first);
         std::vector<bool> rbgAvailableMap = it->second;
@@ -506,7 +505,7 @@
     bool isPrimarySegmentRbg = m_dlPrimarySegmentRbgMap[rbgId];
     bool isSecondarySegmentRbg = m_dlSecondarySegmentRbgMap[rbgId];
 
-    std::map<uint16_t, uint8_t>::iterator it = m_ues.find(rnti);
+    auto it = m_ues.find(rnti);
     if (it == m_ues.end())
     {
         m_ues.insert(std::pair<uint16_t, uint8_t>(rnti, AreaUnset));
@@ -541,7 +540,7 @@
     {
         // check if RB can be used by UE based on CQI information
         NS_LOG_INFO("SECONDARY SEGMENT RNTI: " << rnti << "  rbgId: " << rbgId);
-        std::map<uint16_t, std::vector<bool>>::iterator it = m_dlRbgAvailableforUe.find(rnti);
+        auto it = m_dlRbgAvailableforUe.find(rnti);
         if (it != m_dlRbgAvailableforUe.end())
         {
             NS_LOG_INFO("RNTI: " << rnti << "  rbgId: " << rbgId
@@ -574,8 +573,7 @@
 
     std::vector<bool> rbgMap = m_ulRbgMap;
 
-    std::map<uint16_t, std::vector<bool>>::iterator it;
-    for (it = m_ulRbAvailableforUe.begin(); it != m_ulRbAvailableforUe.end(); it++)
+    for (auto it = m_ulRbAvailableforUe.begin(); it != m_ulRbAvailableforUe.end(); it++)
     {
         NS_LOG_INFO("RNTI : " << it->first);
         std::vector<bool> rbAvailableMap = it->second;
@@ -607,7 +605,7 @@
     bool isPrimarySegmentRbg = m_ulPrimarySegmentRbgMap[rbgId];
     bool isSecondarySegmentRbg = m_ulSecondarySegmentRbgMap[rbgId];
 
-    std::map<uint16_t, uint8_t>::iterator it = m_ues.find(rnti);
+    auto it = m_ues.find(rnti);
     if (it == m_ues.end())
     {
         m_ues.insert(std::pair<uint16_t, uint8_t>(rnti, AreaUnset));
@@ -641,7 +639,7 @@
     {
         // check if RB can be used by UE based on CQI information
         NS_LOG_INFO("UL SECONDARY SEGMENT RNTI: " << rnti << "  rbgId: " << rbgId);
-        std::map<uint16_t, std::vector<bool>>::iterator it = m_ulRbAvailableforUe.find(rnti);
+        auto it = m_ulRbAvailableforUe.find(rnti);
         if (it != m_ulRbAvailableforUe.end())
         {
             NS_LOG_INFO("RNTI: " << rnti << "  rbgId: " << rbgId
@@ -670,10 +668,9 @@
         {
             NS_LOG_INFO("subband CQI reporting high layer configured");
             // subband CQI reporting high layer configured
-            std::map<uint16_t, SbMeasResult_s>::iterator it;
             uint16_t rnti = params.m_cqiList.at(i).m_rnti;
 
-            std::map<uint16_t, uint8_t>::iterator ueIt = m_ues.find(rnti);
+            auto ueIt = m_ues.find(rnti);
             if (ueIt != m_ues.end())
             {
                 if (ueIt->second != CenterArea)
@@ -686,7 +683,7 @@
                 continue;
             }
 
-            it = m_dlCqi.find(rnti);
+            auto it = m_dlCqi.find(rnti);
             if (it == m_dlCqi.end())
             {
                 // create the new entry
@@ -708,8 +705,7 @@
 
     uint32_t rbgSize = GetRbgSize(m_dlBandwidth);
     m_dlRbgAvailableforUe.clear();
-    std::map<uint16_t, SbMeasResult_s>::iterator it;
-    for (it = m_dlCqi.begin(); it != m_dlCqi.end(); it++)
+    for (auto it = m_dlCqi.begin(); it != m_dlCqi.end(); it++)
     {
         uint16_t rnti = it->first;
         std::vector<bool> rbgAvailableMap;
@@ -741,9 +737,7 @@
     }
 
     m_ulRbAvailableforUe.clear();
-    for (std::map<uint16_t, std::vector<bool>>::iterator it = m_dlRbgAvailableforUe.begin();
-         it != m_dlRbgAvailableforUe.end();
-         it++)
+    for (auto it = m_dlRbgAvailableforUe.begin(); it != m_dlRbgAvailableforUe.end(); it++)
     {
         uint16_t rnti = it->first;
         std::vector<bool> dlRbgAvailableMap = it->second;
@@ -796,7 +790,7 @@
                                         uint16_t rb,
                                         std::map<uint16_t, std::vector<double>> ulCqiMap)
 {
-    std::map<uint16_t, std::vector<double>>::iterator itCqi = ulCqiMap.find(rnti);
+    auto itCqi = ulCqiMap.find(rnti);
     if (itCqi == ulCqiMap.end())
     {
         // no cqi info about this UE
@@ -844,7 +838,7 @@
     //------------------------------------------------
     //  here Absolute mode is used
 
-    std::map<uint16_t, uint8_t>::iterator it = m_ues.find(rnti);
+    auto it = m_ues.find(rnti);
     if (it == m_ues.end())
     {
         return 1;
@@ -903,7 +897,7 @@
     }
     else
     {
-        std::map<uint16_t, uint8_t>::iterator it = m_ues.find(rnti);
+        auto it = m_ues.find(rnti);
         if (it == m_ues.end())
         {
             m_ues.insert(std::pair<uint16_t, uint8_t>(rnti, AreaUnset));
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/lte/model/lte-ffr-soft-algorithm.cc ns-3.40/src/lte/model/lte-ffr-soft-algorithm.cc
--- ns-3.39/src/lte/model/lte-ffr-soft-algorithm.cc	2023-07-05 14:23:48.013428000 -0700
+++ ns-3.40/src/lte/model/lte-ffr-soft-algorithm.cc	2023-09-27 13:30:37.818839600 -0700
@@ -424,7 +424,7 @@
     bool isMediumRbg = m_dlMediumRbgMap[rbgId];
     bool isEdgeRbg = m_dlEdgeRbgMap[rbgId];
 
-    std::map<uint16_t, uint8_t>::iterator it = m_ues.find(rnti);
+    auto it = m_ues.find(rnti);
     if (it == m_ues.end())
     {
         m_ues.insert(std::pair<uint16_t, uint8_t>(rnti, AreaUnset));
@@ -485,7 +485,7 @@
     bool isMediumRbg = m_ulMediumRbgMap[rbgId];
     bool isEdgeRbg = m_ulEdgeRbgMap[rbgId];
 
-    std::map<uint16_t, uint8_t>::iterator it = m_ues.find(rnti);
+    auto it = m_ues.find(rnti);
     if (it == m_ues.end())
     {
         m_ues.insert(std::pair<uint16_t, uint8_t>(rnti, AreaUnset));
@@ -563,7 +563,7 @@
     //------------------------------------------------
     //  here Absolute mode is used
 
-    std::map<uint16_t, uint8_t>::iterator it = m_ues.find(rnti);
+    auto it = m_ues.find(rnti);
     if (it == m_ues.end())
     {
         return 1;
@@ -662,7 +662,7 @@
     }
     else
     {
-        std::map<uint16_t, uint8_t>::iterator it = m_ues.find(rnti);
+        auto it = m_ues.find(rnti);
         if (it == m_ues.end())
         {
             m_ues.insert(std::pair<uint16_t, uint8_t>(rnti, AreaUnset));
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/lte/model/lte-fr-soft-algorithm.cc ns-3.40/src/lte/model/lte-fr-soft-algorithm.cc
--- ns-3.39/src/lte/model/lte-fr-soft-algorithm.cc	2023-07-05 14:23:48.013428000 -0700
+++ ns-3.40/src/lte/model/lte-fr-soft-algorithm.cc	2023-09-27 13:30:37.818839600 -0700
@@ -359,7 +359,7 @@
 
     bool edgeRbg = m_dlEdgeRbgMap[rbgId];
 
-    std::map<uint16_t, uint8_t>::iterator it = m_ues.find(rnti);
+    auto it = m_ues.find(rnti);
     if (it == m_ues.end())
     {
         m_ues.insert(std::pair<uint16_t, uint8_t>(rnti, AreaUnset));
@@ -405,7 +405,7 @@
 
     bool edgeRbg = m_ulEdgeRbgMap[rbgId];
 
-    std::map<uint16_t, uint8_t>::iterator it = m_ues.find(rnti);
+    auto it = m_ues.find(rnti);
     if (it == m_ues.end())
     {
         m_ues.insert(std::pair<uint16_t, uint8_t>(rnti, AreaUnset));
@@ -470,7 +470,7 @@
     //------------------------------------------------
     //  here Absolute mode is used
 
-    std::map<uint16_t, uint8_t>::iterator it = m_ues.find(rnti);
+    auto it = m_ues.find(rnti);
     if (it == m_ues.end())
     {
         return 1;
@@ -536,7 +536,7 @@
     }
     else
     {
-        std::map<uint16_t, uint8_t>::iterator it = m_ues.find(rnti);
+        auto it = m_ues.find(rnti);
         if (it == m_ues.end())
         {
             m_ues.insert(std::pair<uint16_t, uint8_t>(rnti, AreaUnset));
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/lte/model/lte-fr-strict-algorithm.cc ns-3.40/src/lte/model/lte-fr-strict-algorithm.cc
--- ns-3.39/src/lte/model/lte-fr-strict-algorithm.cc	2023-07-05 14:23:48.013428000 -0700
+++ ns-3.40/src/lte/model/lte-fr-strict-algorithm.cc	2023-09-27 13:30:37.818839600 -0700
@@ -397,7 +397,7 @@
 
     bool edgeRbg = m_dlEdgeRbgMap[rbgId];
 
-    std::map<uint16_t, uint8_t>::iterator it = m_ues.find(rnti);
+    auto it = m_ues.find(rnti);
     if (it == m_ues.end())
     {
         m_ues.insert(std::pair<uint16_t, uint8_t>(rnti, AreaUnset));
@@ -438,7 +438,7 @@
 
     bool edgeRbg = m_ulEdgeRbgMap[rbgId];
 
-    std::map<uint16_t, uint8_t>::iterator it = m_ues.find(rnti);
+    auto it = m_ues.find(rnti);
     if (it == m_ues.end())
     {
         m_ues.insert(std::pair<uint16_t, uint8_t>(rnti, AreaUnset));
@@ -498,7 +498,7 @@
     //------------------------------------------------
     //  here Absolute mode is used
 
-    std::map<uint16_t, uint8_t>::iterator it = m_ues.find(rnti);
+    auto it = m_ues.find(rnti);
     if (it == m_ues.end())
     {
         return 1;
@@ -548,7 +548,7 @@
     }
     else
     {
-        std::map<uint16_t, uint8_t>::iterator it = m_ues.find(rnti);
+        auto it = m_ues.find(rnti);
         if (it == m_ues.end())
         {
             m_ues.insert(std::pair<uint16_t, uint8_t>(rnti, AreaUnset));
